commit b7a821d36cca44600a0604ca88052f12ded238f9
Author: Marc Dequènes (Duck) <Duck@DuckCorp.org>
Date:   Mon Mar 7 03:56:34 2011 +0100

    [l10n] regenerated po files

diff --git a/po/cyborghood.pot b/po/cyborghood.pot
index 09081b4..5a4ef70 100644
--- a/po/cyborghood.pot
+++ b/po/cyborghood.pot
@@ -6,100 +6,61 @@
 #, fuzzy
 msgid ""
 msgstr ""
-"Project-Id-Version: CyborgHood 0.2.0~dev\n"
-"POT-Creation-Date: 2010-04-04 17:37+0200\n"
+"Project-Id-Version: CyborgHood 0.4.0\n"
+"POT-Creation-Date: 2011-03-07 02:42+0100\n"
 "PO-Revision-Date: 2009-03-07 21:38+0100\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language-Team: LANGUAGE <LL@li.org>\n"
+"Language: \n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=INTEGER; plural=EXPRESSION;\n"
 
-#: lib/cyborghood/order.rb:57
+#: lib/cyborghood/order.rb:96
 msgid "Syntax error in command."
 msgstr ""
 
-#: lib/cyborghood/mail.rb:92
-msgid "Replay detected."
-msgstr ""
-
-#: lib/cyborghood/mail.rb:98
-msgid "Mail not RFC3156 compliant."
-msgstr ""
-
-#: lib/cyborghood/mail.rb:172
-msgid "Mail not formatted correctly (signed part)."
-msgstr ""
-
-#: lib/cyborghood/mail.rb:175
-msgid "Mail content tampered or badly signed: %{sig_err}"
-msgstr ""
-
-#: lib/cyborghood/mail.rb:179
-msgid "Mail is from an unknown person."
-msgstr ""
-
-#: lib/cyborghood/mail.rb:188
-msgid ""
-"The signature was made too long ago (check your system clock). Rejected "
-"message to avoid replay attacks."
-msgstr ""
-
-#: lib/cyborghood/mail.rb:192
-msgid ""
-"The signature was made in the future (check your system clock). Rejected "
-"message to avoid replay attacks."
-msgstr ""
-
-#: lib/cyborghood/mail.rb:237
-msgid "Mail not formatted correctly (encrypted part)."
-msgstr ""
-
-#: lib/cyborghood/mail_order.rb:25
-msgid "Mail does not contain a proper text part for commands."
-msgstr ""
-
-#: lib/cyborghood/mail_order.rb:38
-msgid "Attachment '%{ref}' not found."
-msgstr ""
-
-#: lib/cyborghood/command_runner.rb:47 lib/cyborghood/command_runner.rb:157
+#: lib/cyborghood/command_runner.rb:46 lib/cyborghood/command_runner.rb:161
 msgid "Internal error. Administrator is warned."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:75
+#: lib/cyborghood/command_runner.rb:74
 msgid "You are manager of the following zones: %{zone_list}."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:85 lib/cyborghood/command_runner.rb:107
+#: lib/cyborghood/command_runner.rb:84 lib/cyborghood/command_runner.rb:108
 msgid "This zone is not hosted here."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:89 lib/cyborghood/command_runner.rb:111
+#: lib/cyborghood/command_runner.rb:88 lib/cyborghood/command_runner.rb:112
 msgid "You are not allowed to manage this zone."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:95
+#: lib/cyborghood/command_runner.rb:96
 msgid "Requested zone content attached."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:120
-msgid "Attachment has wrong content-type."
+#: lib/cyborghood/command_runner.rb:118
+msgid "No attachment number provided"
+msgstr ""
+
+#: lib/cyborghood/command_runner.rb:124
+msgid "Zone data has wrong content-type."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:135
+#: lib/cyborghood/command_runner.rb:139
 msgid "Invalid zone data."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:142
+#: lib/cyborghood/command_runner.rb:146
 msgid "Zone serial is not superior to current serial."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:153
+#: lib/cyborghood/command_runner.rb:157
 msgid "Zone updated."
 msgstr ""
 
-#: lib/cyborghood/command_runner.rb:171
+#: lib/cyborghood/command_runner.rb:175
 msgid "Command not recognized."
 msgstr ""
diff --git a/po/cyborghood_librarian.pot b/po/cyborghood_librarian.pot
new file mode 100644
index 0000000..ff578c3
--- /dev/null
+++ b/po/cyborghood_librarian.pot
@@ -0,0 +1,18 @@
+# SOME DESCRIPTIVE TITLE.
+# Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
+# This file is distributed under the same license as the PACKAGE package.
+# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
+#
+#, fuzzy
+msgid ""
+msgstr ""
+"Project-Id-Version: CyborgHood 0.4.0\n"
+"POT-Creation-Date: 2011-03-07 02:41+0100\n"
+"PO-Revision-Date: 2011-03-07 02:41+0100\n"
+"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
+"Language-Team: LANGUAGE <LL@li.org>\n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"Plural-Forms: nplurals=INTEGER; plural=EXPRESSION;\n"
+
diff --git a/po/cyborghood_mapmaker.pot b/po/cyborghood_mapmaker.pot
new file mode 100644
index 0000000..8a028ba
--- /dev/null
+++ b/po/cyborghood_mapmaker.pot
@@ -0,0 +1,30 @@
+# SOME DESCRIPTIVE TITLE.
+# Copyright (C) YEAR THE PACKAGE'S COPYRIGHT HOLDER
+# This file is distributed under the same license as the PACKAGE package.
+# FIRST AUTHOR <EMAIL@ADDRESS>, YEAR.
+#
+#, fuzzy
+msgid ""
+msgstr ""
+"Project-Id-Version: CyborgHood 0.4.0\n"
+"POT-Creation-Date: 2011-03-07 02:42+0100\n"
+"PO-Revision-Date: 2011-03-07 02:39+0100\n"
+"Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
+"Language-Team: LANGUAGE <LL@li.org>\n"
+"Language: \n"
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=UTF-8\n"
+"Content-Transfer-Encoding: 8bit\n"
+"Plural-Forms: nplurals=INTEGER; plural=EXPRESSION;\n"
+
+#: lib/cyborghood-mapmaker/zone.rb:101
+msgid "DNS and DNSSEC original zone files do not match"
+msgstr ""
+
+#: lib/cyborghood-mapmaker/zone.rb:104
+msgid "DNS and DNSSEC signed zone files do not match"
+msgstr ""
+
+#: lib/cyborghood-mapmaker/zone.rb:111
+msgid "The zone serial does not match the one in the zone file"
+msgstr ""
diff --git a/po/cyborghood_postman.pot b/po/cyborghood_postman.pot
index bf90eaf..6db9257 100644
--- a/po/cyborghood_postman.pot
+++ b/po/cyborghood_postman.pot
@@ -6,44 +6,89 @@
 #, fuzzy
 msgid ""
 msgstr ""
-"Project-Id-Version: CyborgHood 0.2.0~dev\n"
-"POT-Creation-Date: 2010-04-04 17:37+0200\n"
+"Project-Id-Version: CyborgHood 0.4.0\n"
+"POT-Creation-Date: 2011-03-07 02:42+0100\n"
 "PO-Revision-Date: 2009-03-07 21:38+0100\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
 "Language-Team: LANGUAGE <LL@li.org>\n"
+"Language: \n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=INTEGER; plural=EXPRESSION;\n"
 
-#: /opt/cyborghood-dev/bin/postman:145 /opt/cyborghood-dev/bin/postman:161
+#: bin/postman:118 bin/postman:135
 msgid "Hello %{cn},"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:145
+#: bin/postman:118
 msgid "Hello,"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:147
+#: bin/postman:120
 msgid ""
 "A message (ID: %{id}), apparently from you, was rejected for the following "
 "reason:"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:166
+#: bin/postman:140
 msgid ""
 "An order, in a message (ID: %{id}) from you, was rejected for the following "
 "reason:"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:180
+#: bin/postman:153
 msgid "Follows the transcript of your commands:"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:229
+#: lib/cyborghood-postman/mail.rb:87
+msgid "Replay detected."
+msgstr ""
+
+#: lib/cyborghood-postman/mail.rb:94
+msgid "Mail not RFC3156 compliant."
+msgstr ""
+
+#: lib/cyborghood-postman/mail.rb:140
 msgid "Contact eMail:"
 msgstr ""
 
-#: /opt/cyborghood-dev/bin/postman:230
+#: lib/cyborghood-postman/mail.rb:141
 msgid "Contact URL:"
 msgstr ""
+
+#: lib/cyborghood-postman/mail.rb:182
+msgid "Mail not formatted correctly (signed part)."
+msgstr ""
+
+#: lib/cyborghood-postman/mail.rb:185
+msgid "Mail content tampered or badly signed: %{sig_err}"
+msgstr ""
+
+#: lib/cyborghood-postman/mail.rb:189
+msgid "Mail is from an unknown person."
+msgstr ""
+
+#: lib/cyborghood-postman/mail.rb:198
+msgid ""
+"The signature was made too long ago (check your system clock). Rejected "
+"message to avoid replay attacks."
+msgstr ""
+
+#: lib/cyborghood-postman/mail.rb:202
+msgid ""
+"The signature was made in the future (check your system clock). Rejected "
+"message to avoid replay attacks."
+msgstr ""
+
+#: lib/cyborghood-postman/mail.rb:251
+msgid "Mail not formatted correctly (encrypted part)."
+msgstr ""
+
+#: lib/cyborghood-postman/mail_order.rb:45
+msgid "Mail does not contain a proper text part for commands."
+msgstr ""
+
+#: lib/cyborghood-postman/mail_order.rb:61
+msgid "Attachment '%{ref}' not found."
+msgstr ""
diff --git a/po/fr/cyborghood.po b/po/fr/cyborghood.po
index 8387b0f..c916eaa 100644
--- a/po/fr/cyborghood.po
+++ b/po/fr/cyborghood.po
@@ -1,13 +1,13 @@
 # CyborgHood
-# Copyright (C) 2009-2010 DuckCorp
+# Copyright (C) 2009-2011 DuckCorp
 # This file is distributed under the same license as the CyborgHood package.
 # Marc Dequènes (Duck) <Duck@DuckCorp.org>, 2009-2010.
 #
 #, fuzzy
 msgid ""
 msgstr ""
-"Project-Id-Version: CyborgHood 0.2.0~dev\n"
-"POT-Creation-Date: 2010-04-04 17:37+0200\n"
+"Project-Id-Version: CyborgHood 0.4.0\n"
+"POT-Creation-Date: 2011-03-07 02:42+0100\n"
 "PO-Revision-Date: 2010-04-04 20:59+0100\n"
 "Last-Translator: Marc Dequènes (Duck) <Duck@DuckCorp.org>\n"
 "MIME-Version: 1.0\n"
@@ -15,95 +15,90 @@ msgstr ""
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n > 1);\n"
 
-#: lib/cyborghood/order.rb:57
+#: lib/cyborghood/order.rb:96
 msgid "Syntax error in command."
 msgstr "Erreur de syntaxe dans la commande."
 
-#: lib/cyborghood/mail.rb:92
-msgid "Replay detected."
-msgstr "Rejeu détecté."
-
-#: lib/cyborghood/mail.rb:98
-msgid "Mail not RFC3156 compliant."
-msgstr "Mail ne respectant pas la RFC3156."
-
-#: lib/cyborghood/mail.rb:172
-msgid "Mail not formatted correctly (signed part)."
-msgstr "Mail formaté incorrectement (partie signée)."
-
-#: lib/cyborghood/mail.rb:175
-msgid "Mail content tampered or badly signed: %{sig_err}"
-msgstr "Contenu du mail altéré ou mal signé: %{sig_err}"
-
-#: lib/cyborghood/mail.rb:179
-msgid "Mail is from an unknown person."
-msgstr "Mail provenant d'une personne inconnue"
-
-#: lib/cyborghood/mail.rb:188
-msgid ""
-"The signature was made too long ago (check your system clock). Rejected "
-"message to avoid replay attacks."
-msgstr ""
-"La signature a été faite depuis trop longtemps (vérifiez votre horloge "
-"système. Message rejeté pour éviter les attaques par rejeux."
-
-#: lib/cyborghood/mail.rb:192
-msgid ""
-"The signature was made in the future (check your system clock). Rejected "
-"message to avoid replay attacks."
-msgstr ""
-"La signature a été faite dans le futur (vérifiez votre horloge système. "
-"Message rejeté pour éviter les attaques par rejeux."
-
-#: lib/cyborghood/mail.rb:237
-msgid "Mail not formatted correctly (encrypted part)."
-msgstr "Mail formaté incorrectement (partie chiffrée)."
-
-#: lib/cyborghood/mail_order.rb:25
-msgid "Mail does not contain a proper text part for commands."
-msgstr ""
-"Le mail ne contient pas de partie textuelle correcte pour les commandes."
-
-#: lib/cyborghood/mail_order.rb:38
-msgid "Attachment '%{ref}' not found."
-msgstr "La pièce jointe '%{ref}' n'a pas été trouvée."
-
-#: lib/cyborghood/command_runner.rb:47 lib/cyborghood/command_runner.rb:157
+#: lib/cyborghood/command_runner.rb:46 lib/cyborghood/command_runner.rb:161
 msgid "Internal error. Administrator is warned."
 msgstr "Erreur interne. L'administrateur a été prévenu."
 
-#: lib/cyborghood/command_runner.rb:75
+#: lib/cyborghood/command_runner.rb:74
 msgid "You are manager of the following zones: %{zone_list}."
 msgstr "Vous gérez les zones suivantes : %{zone_list}."
 
-#: lib/cyborghood/command_runner.rb:85 lib/cyborghood/command_runner.rb:107
+#: lib/cyborghood/command_runner.rb:84 lib/cyborghood/command_runner.rb:108
 msgid "This zone is not hosted here."
 msgstr "Cette zone n'est pas hébergée ici."
 
-#: lib/cyborghood/command_runner.rb:89 lib/cyborghood/command_runner.rb:111
+#: lib/cyborghood/command_runner.rb:88 lib/cyborghood/command_runner.rb:112
 msgid "You are not allowed to manage this zone."
 msgstr "Vous n'êtes pas autorisé à gérer cette zone."
 
-#: lib/cyborghood/command_runner.rb:95
+#: lib/cyborghood/command_runner.rb:96
 msgid "Requested zone content attached."
 msgstr "Le contenu de la zone demandée est en pièce jointe."
 
-#: lib/cyborghood/command_runner.rb:120
-msgid "Attachment has wrong content-type."
+#: lib/cyborghood/command_runner.rb:118
+msgid "No attachment number provided"
+msgstr ""
+
+#: lib/cyborghood/command_runner.rb:124
+#, fuzzy
+msgid "Zone data has wrong content-type."
 msgstr "La pièce jointe a un mauvais type de contenu (content-type)."
 
-#: lib/cyborghood/command_runner.rb:135
+#: lib/cyborghood/command_runner.rb:139
 msgid "Invalid zone data."
 msgstr "Données pour la zone invalides."
 
-#: lib/cyborghood/command_runner.rb:142
+#: lib/cyborghood/command_runner.rb:146
 msgid "Zone serial is not superior to current serial."
 msgstr "Le numéro de série de la zone n'est pas supèrieur à celui actuel."
 
-#: lib/cyborghood/command_runner.rb:153
+#: lib/cyborghood/command_runner.rb:157
 msgid "Zone updated."
 msgstr "Zone mise à jour."
 
-#: lib/cyborghood/command_runner.rb:171
+#: lib/cyborghood/command_runner.rb:175
 msgid "Command not recognized."
 msgstr "Commande non reconnue."
+
+#~ msgid "Replay detected."
+#~ msgstr "Rejeu détecté."
+
+#~ msgid "Mail not RFC3156 compliant."
+#~ msgstr "Mail ne respectant pas la RFC3156."
+
+#~ msgid "Mail not formatted correctly (signed part)."
+#~ msgstr "Mail formaté incorrectement (partie signée)."
+
+#~ msgid "Mail content tampered or badly signed: %{sig_err}"
+#~ msgstr "Contenu du mail altéré ou mal signé: %{sig_err}"
+
+#~ msgid "Mail is from an unknown person."
+#~ msgstr "Mail provenant d'une personne inconnue"
+
+#~ msgid ""
+#~ "The signature was made too long ago (check your system clock). Rejected "
+#~ "message to avoid replay attacks."
+#~ msgstr ""
+#~ "La signature a été faite depuis trop longtemps (vérifiez votre horloge "
+#~ "système. Message rejeté pour éviter les attaques par rejeux."
+
+#~ msgid ""
+#~ "The signature was made in the future (check your system clock). Rejected "
+#~ "message to avoid replay attacks."
+#~ msgstr ""
+#~ "La signature a été faite dans le futur (vérifiez votre horloge système. "
+#~ "Message rejeté pour éviter les attaques par rejeux."
+
+#~ msgid "Mail not formatted correctly (encrypted part)."
+#~ msgstr "Mail formaté incorrectement (partie chiffrée)."
+
+#~ msgid "Mail does not contain a proper text part for commands."
+#~ msgstr ""
+#~ "Le mail ne contient pas de partie textuelle correcte pour les commandes."
+
+#~ msgid "Attachment '%{ref}' not found."
+#~ msgstr "La pièce jointe '%{ref}' n'a pas été trouvée."
diff --git a/po/fr/cyborghood_postman.po b/po/fr/cyborghood_postman.po
index 2570186..f68990d 100644
--- a/po/fr/cyborghood_postman.po
+++ b/po/fr/cyborghood_postman.po
@@ -1,13 +1,13 @@
 # CyborgHood
-# Copyright (C) 2009-2010 DuckCorp
+# Copyright (C) 2009-2011 DuckCorp
 # This file is distributed under the same license as the CyborgHood package.
 # Marc Dequènes (Duck) <Duck@DuckCorp.org>, 2009-2010.
 #
 #, fuzzy
 msgid ""
 msgstr ""
-"Project-Id-Version: CyborgHood 0.2.0~dev\n"
-"POT-Creation-Date: 2010-04-04 17:37+0200\n"
+"Project-Id-Version: CyborgHood 0.4.0\n"
+"POT-Creation-Date: 2011-03-07 02:42+0100\n"
 "PO-Revision-Date: 2010-04-04 21:27+0100\n"
 "Last-Translator: Marc Dequènes (Duck) <Duck@DuckCorp.org>\n"
 "MIME-Version: 1.0\n"
@@ -15,15 +15,15 @@ msgstr ""
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n > 1);\n"
 
-#: /opt/cyborghood-dev/bin/postman:145 /opt/cyborghood-dev/bin/postman:161
+#: bin/postman:118 bin/postman:135
 msgid "Hello %{cn},"
 msgstr "Bonjour %{cn},"
 
-#: /opt/cyborghood-dev/bin/postman:145
+#: bin/postman:118
 msgid "Hello,"
 msgstr "Bonjour,"
 
-#: /opt/cyborghood-dev/bin/postman:147
+#: bin/postman:120
 msgid ""
 "A message (ID: %{id}), apparently from you, was rejected for the following "
 "reason:"
@@ -31,7 +31,7 @@ msgstr ""
 "Un message (ID: %{id}), provenant apparemment de vous, a été rejeté pour la "
 "raison suivante :"
 
-#: /opt/cyborghood-dev/bin/postman:166
+#: bin/postman:140
 msgid ""
 "An order, in a message (ID: %{id}) from you, was rejected for the following "
 "reason:"
@@ -39,14 +39,58 @@ msgstr ""
 "Un order, dans in message (ID: %{id}) venant de vous, a été rejeté pour la "
 "raison suivante :"
 
-#: /opt/cyborghood-dev/bin/postman:180
+#: bin/postman:153
 msgid "Follows the transcript of your commands:"
 msgstr "La retranscription des commandes suit :"
 
-#: /opt/cyborghood-dev/bin/postman:229
+#: lib/cyborghood-postman/mail.rb:87
+msgid "Replay detected."
+msgstr ""
+
+#: lib/cyborghood-postman/mail.rb:94
+msgid "Mail not RFC3156 compliant."
+msgstr ""
+
+#: lib/cyborghood-postman/mail.rb:140
 msgid "Contact eMail:"
 msgstr "eMail de Contact :"
 
-#: /opt/cyborghood-dev/bin/postman:230
+#: lib/cyborghood-postman/mail.rb:141
 msgid "Contact URL:"
 msgstr "URL de Contact :"
+
+#: lib/cyborghood-postman/mail.rb:182
+msgid "Mail not formatted correctly (signed part)."
+msgstr ""
+
+#: lib/cyborghood-postman/mail.rb:185
+msgid "Mail content tampered or badly signed: %{sig_err}"
+msgstr ""
+
+#: lib/cyborghood-postman/mail.rb:189
+msgid "Mail is from an unknown person."
+msgstr ""
+
+#: lib/cyborghood-postman/mail.rb:198
+msgid ""
+"The signature was made too long ago (check your system clock). Rejected "
+"message to avoid replay attacks."
+msgstr ""
+
+#: lib/cyborghood-postman/mail.rb:202
+msgid ""
+"The signature was made in the future (check your system clock). Rejected "
+"message to avoid replay attacks."
+msgstr ""
+
+#: lib/cyborghood-postman/mail.rb:251
+msgid "Mail not formatted correctly (encrypted part)."
+msgstr ""
+
+#: lib/cyborghood-postman/mail_order.rb:45
+msgid "Mail does not contain a proper text part for commands."
+msgstr ""
+
+#: lib/cyborghood-postman/mail_order.rb:61
+msgid "Attachment '%{ref}' not found."
+msgstr ""